## qmplay2 24.06.16

=== src/qmvk/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(QmVk)

set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_INCLUDE_CURRENT_DIR OFF)

set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_STANDARD 17)

if(QMVK_FIND_VULKAN)
    find_package(Vulkan REQUIRED)
endif()

if(NOT QMVK_GLSLC_COMMAND)
    set(QMVK_GLSLC_COMMAND "glslc" CACHE INTERNAL "")
endif()
if(NOT QMVK_TARGET_ENV)
    set(QMVK_TARGET_ENV "vulkan1.0" CACHE INTERNAL "")
endif()

macro(qmvk_add_shader SHADER_SOURCE_FILE)
    set(EXTRA_ARGS ${ARGN})
    list(LENGTH EXTRA_ARGS NUM_EXTRA_ARGS)
    if(${NUM_EXTRA_ARGS} GREATER 0)
        set(SHADER_DEPENDENCIES ${EXTRA_ARGS})
    endif()
    unset(NUM_EXTRA_ARGS)
    unset(EXTRA_ARGS)

    get_filename_component(SHADER_SOURCE_FILE_NAME ${SHADER_SOURCE_FILE} NAME)

    get_filename_component(SHADER_SOURCE_STAGE ${SHADER_SOURCE_FILE} LAST_EXT)
    string(TOLOWER ${SHADER_SOURCE_STAGE} SHADER_SOURCE_STAGE)
    if(SHADER_SOURCE_STAGE MATCHES ".glsl")
        get_filename_component(SHADER_SOURCE_STAGE ${SHADER_SOURCE_FILE} NAME_WLE)
        get_filename_component(SHADER_SOURCE_STAGE ${SHADER_SOURCE_STAGE} LAST_EXT)
        string(TOLOWER ${SHADER_SOURCE_STAGE} SHADER_SOURCE_STAGE)
    endif()
    string(SUBSTRING ${SHADER_SOURCE_STAGE} 1 -1 SHADER_SOURCE_STAGE)

    set(SHADER_COMPILED_FILES_DIR "${CMAKE_CURRENT_BINARY_DIR}/qmvk_shaders")
    set(SHADER_COMPILED_FILE_NAME "${SHADER_SOURCE_FILE_NAME}.spv")
    set(SHADER_COMPILED_FILE "${SHADER_COMPILED_FILES_DIR}/${SHADER_COMPILED_FILE_NAME}")

    add_custom_command(
        OUTPUT ${SHADER_COMPILED_FILE}
        DEPENDS ${SHADER_SOURCE_FILE} ${SHADER_DEPENDENCIES}
        COMMAND ${CMAKE_COMMAND} -E make_directory ${SHADER_COMPILED_FILES_DIR}
        COMMAND ${QMVK_GLSLC_COMMAND} -std=460 --target-env=${QMVK_TARGET_ENV} -fshader-stage=${SHADER_SOURCE_STAGE} -o ${SHADER_COMPILED_FILE} ${SHADER_SOURCE_FILE}
    )

    list(APPEND QMVK_SHADER_COMPILED_FILES ${SHADER_COMPILED_FILE})

    unset(SHADER_COMPILED_FILE)
    unset(SHADER_COMPILED_FILE_NAME)
    unset(SHADER_COMPILED_FILES_DIR)
    unset(SHADER_SOURCE_STAGE)
    unset(SHADER_SOURCE_FILE_NAME)

    unset(SHADER_DEPENDENCIES)
endmacro()

file(GLOB QMVK_VULKAN_HDR
    "*.hpp"
)
file(GLOB QMVK_VULKAN_SRC
    "*.cpp"
)
if(QMVK_NO_GRAPHICS)
    list(REMOVE_ITEM QMVK_VULKAN_HDR
        "${CMAKE_CURRENT_SOURCE_DIR}/GraphicsPipeline.hpp"
        "${CMAKE_CURRENT_SOURCE_DIR}/Image.hpp"
        "${CMAKE_CURRENT_SOURCE_DIR}/RenderPass.hpp"
        "${CMAKE_CURRENT_SOURCE_DIR}/Sampler.hpp"
        "${CMAKE_CURRENT_SOURCE_DIR}/SwapChain.hpp"
    )
    list(REMOVE_ITEM QMVK_VULKAN_SRC
        "${CMAKE_CURRENT_SOURCE_DIR}/GraphicsPipeline.cpp"
        "${CMAKE_CURRENT_SOURCE_DIR}/Image.cpp"
        "${CMAKE_CURRENT_SOURCE_DIR}/RenderPass.cpp"
        "${CMAKE_CURRENT_SOURCE_DIR}/Sampler.cpp"
        "${CMAKE_CURRENT_SOURCE_DIR}/SwapChain.cpp"
    )
endif()

add_library(${PROJECT_NAME} OBJECT
    ${QMVK_VULKAN_HDR}
    ${QMVK_VULKAN_SRC}
)

if(QMVK_USE_PCH)
    target_precompile_headers(${PROJECT_NAME}
        PRIVATE
        ${QMVK_VULKAN_HDR}
    )
endif()

target_include_directories(
    ${PROJECT_NAME}
    PUBLIC
    ${Vulkan_INCLUDE_DIRS}
)

target_compile_definitions(${PROJECT_NAME}
    PUBLIC
    -DVK_NO_PROTOTYPES
    -DVULKAN_HPP_TYPESAFE_CONVERSION
    -DVULKAN_HPP_NO_STRUCT_SETTERS
    -DNOMINMAX
)
if(QMVK_NO_GRAPHICS)
    target_compile_definitions(${PROJECT_NAME}
        PUBLIC
        -DQMVK_NO_GRAPHICS
    )
elseif(QMVK_USE_IMAGE_BUFFER_VIEW)
    target_compile_definitions(${PROJECT_NAME}
        PUBLIC
        -DQMVK_USE_IMAGE_BUFFER_VIEW
    )
endif()

if(QMVK_APPLY_MEMORY_PROPERTIES_QUIRKS)
    target_compile_definitions(${PROJECT_NAME}
        PUBLIC
        -DQMVK_APPLY_MEMORY_PROPERTIES_QUIRKS
    )
endif()

if(QMVK_NO_EXPORT)
    target_compile_definitions(${PROJECT_NAME}
        PUBLIC
        -DQMVK_NO_EXPORT
    )
endif()

if(QMVK_WAIT_TIMEOUT_MS)
    target_compile_definitions(${PROJECT_NAME}
        PUBLIC
        -DQMVK_WAIT_TIMEOUT_MS=${QMVK_WAIT_TIMEOUT_MS}
    )
endif()

if(WIN32)
    target_compile_definitions(${PROJECT_NAME}
        PUBLIC
        -DVK_USE_PLATFORM_WIN32_KHR
        PRIVATE
        -DQMVK_LIBRARY
    )
elseif(ANDROID)
    target_compile_definitions(${PROJECT_NAME}
        PUBLIC
        -DVK_USE_PLATFORM_ANDROID_KHR
    )
endif()

=== src/modules/AudioFilters/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(AudioFilters)

set(AudioFilters_HDR
    AudioFilters.hpp
    Equalizer.hpp
    EqualizerGUI.hpp
    VoiceRemoval.hpp
    PhaseReverse.hpp
    SwapStereo.hpp
    Echo.hpp
    DysonCompressor.hpp
    BS2B.hpp
    bs2b/bs2b.hpp
    bs2b/bs2bversion.hpp
)

set(AudioFilters_SRC
    AudioFilters.cpp
    Equalizer.cpp
    EqualizerGUI.cpp
    VoiceRemoval.cpp
    PhaseReverse.cpp
    SwapStereo.cpp
    Echo.cpp
    DysonCompressor.cpp
    BS2B.cpp
    bs2b/bs2b_lib.cpp
)

set(AudioFilters_RESOURCES
    icon.qrc
)

add_library(${PROJECT_NAME} MODULE
    ${AudioFilters_HDR}
    ${AudioFilters_SRC}
    ${AudioFilters_RESOURCES}
)

if(USE_PCH)
    target_precompile_headers(${PROJECT_NAME} PRIVATE
        ${AudioFilters_HDR}
    )
endif()

libqmplay2_set_target_params()

install(TARGETS ${PROJECT_NAME} LIBRARY DESTINATION ${MODULES_INSTALL_PATH})

=== src/modules/Extensions/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(Extensions)

set(Extensions_HDR
    Extensions.hpp
    Downloader.hpp
)

set(Extensions_SRC
    Extensions.cpp
    Downloader.cpp
)

set(Extensions_RESOURCES
    icons.qrc
)

if(USE_MPRIS2)
    list(APPEND Extensions_HDR MPRIS2.hpp)
    list(APPEND Extensions_SRC MPRIS2.cpp)
    add_definitions(-DUSE_MPRIS2)
endif()

if(USE_LASTFM)
    list(APPEND Extensions_HDR LastFM.hpp)
    list(APPEND Extensions_SRC LastFM.cpp)
    add_definitions(-DUSE_LASTFM)
endif()

if(USE_LYRICS)
    list(APPEND Extensions_HDR Lyrics.hpp)
    list(APPEND Extensions_SRC Lyrics.cpp)
    add_definitions(-DUSE_LYRICS)
endif()

if(USE_MEDIABROWSER)
    list(APPEND Extensions_HDR MediaBrowser.hpp MediaBrowserJS.hpp)
    list(APPEND Extensions_SRC MediaBrowser.cpp MediaBrowserJS.cpp)
    list(APPEND Extensions_RESOURCES js.qrc)
    add_definitions(-DUSE_MEDIABROWSER)
    set(QML ${QT_PREFIX}::Qml)
endif()

if(USE_RADIO)
    list(APPEND Extensions_HDR
        Radio.hpp
        Radio/RadioBrowserModel.hpp
    )
    list(APPEND Extensions_SRC
        Radio.cpp
        Radio/RadioBrowserModel.cpp
    )
    set(Extensions_FORMS
        Radio/Radio.ui
    )
    add_definitions(-DUSE_RADIO)
endif()

if(USE_YOUTUBE)
    list(APPEND Extensions_HDR YouTube.hpp)
    list(APPEND Extensions_SRC YouTube.cpp)
    add_definitions(-DUSE_YOUTUBE)
endif()

if(BUILD_WITH_QT6)
    qt6_wrap_ui(Extensions_FORM_HDR ${Extensions_FORMS})
else()
    qt5_wrap_ui(Extensions_FORM_HDR ${Extensions_FORMS})
endif()
set_property(SOURCE ${Extensions_FORM_HDR} PROPERTY SKIP_AUTOMOC ON)

add_library(${PROJECT_NAME} MODULE
    ${Extensions_HDR}
    ${Extensions_SRC}
    ${Extensions_FORM_HDR}
    ${Extensions_RESOURCES}
)

if(USE_PCH)
    target_precompile_headers(${PROJECT_NAME} PRIVATE
        ${Extensions_HDR}
    )
endif()

target_link_libraries(${PROJECT_NAME}
    PRIVATE
    ${QML}
)
libqmplay2_set_target_params()

install(TARGETS ${PROJECT_NAME} LIBRARY DESTINATION ${MODULES_INSTALL_PATH})

=== debian/changelog ===
qmplay2 (1:24.06.16-1mx23+1qt6) mx; urgency=medium

  * Rebuild with Qt6.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 22 Jun 2024 08:59:00 -0700

qmplay2 (1:24.06.16-1mx21+1) mx; urgency=medium

  * Import new upstream 24.06.16 release:
    - show less connection errors from Radio Browser.
    - fix choosing desired video stream.
    - fix colorspace for ARIB STD-B67.
    - improve recording status.
    - update translations.

  * Disable Vulkan, causes FTBFS now with older versions.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 22 Jun 2024 07:33:47 -0700

qmplay2 (1:24.05.23-1mx23+1) mx; urgency=medium

  * Import new upstream 24.05.23 release:
    - don't try to split title/artist on internet radio stations.
    - fix "blend" and "discard" deinterlacing filters on Vulkan.
    - remove "USE_LINK_TIME_OPTIMIZATION" CMake parameter.
    - don't automatically clear "stop after" on playlist.
    - allow to change more colors for custom appearance.
    - add "negative" video filter (Vulkan and OpenGL).
    - don't show "windows11" style on older Windows.
    - allow to choose desired video stream quality.
    - allow to load playlists from YouTube link.
    - move downloader path to general settings.
    - fix screen saver inhibition on Windows.
    - require CMake 3.16, C++17, and Ninja.
    - use native file dialogs on Android.
    - download only best video stream.
    - add recording for live streams.
    - add removing files from disk.
    - add paste and play function.
    - drop Qt older than 5.15.2.
    - downloader improvements.
    - display AVIF images.
    - remove VDPAU.
    - other minor fixes.
 
  * Add ninja-build to Build-Deps.
  * Drop pkg-config as Build-Dep.
  * Debian/rules: build system us cmake+nija, and add build ovverrides from
    dmo build.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 27 May 2024 20:46:32 -0700

qmplay2 (1:24.04.07-1mx23+1) mx; urgency=medium

  * Import new upstream 24.04.07 release:
    - fix wrong path separator on Windows after accepting file properties.
    - fix file properties crash on Windows distribution (taglib bug).
    - add hotkeys for playlist and info dock visibility.
    - inhibit screensaver through D-Bus interface.
    - don't show visualizations by default.
    - change hide menu hotkey to Shift+M.
    - lock widgets by default.
    - other minor fixes.

  * Add libvulkan-dev to Build-Deps.
  * d/rules: enable Vulkan, link time optimization, interprocedural
    optimization, undefined behavior sanitization, and precompiled headers.

 -- Steven Pusser <stevep@mxlinux.org>  Tue, 28 May 2024 14:56:19 -0700

=== debian/control ===
Source: qmplay2
Section: video
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Rog131 <samrog131@hotmail.com>
Build-Depends: cmake (>= 3.16),
               debhelper-compat (= 12),
               libasound2-dev,
               libass-dev,
               libavcodec-dev (>= 7:4.0),
               libavdevice-dev (>= 7:4.0),
               libcddb2-dev,
               libcdio-dev,
               libegl1-mesa-dev,
               libgme-dev,
               libjack-dev,
               libpipewire-0.3-dev,
               libpulse-dev,
               libqt6opengl6-dev,
               librubberband-dev (>= 3.0),
               libsidplayfp-dev (>= 1.6),
               libtag1-dev (>= 1.9),
               libva-dev,
#               libvulkan-dev,
               libxv-dev,
               ninja-build,
               pkgconf,
               portaudio19-dev,
               qt6-5compat-dev,
               qt6-base-dev,
               qt6-base-dev-tools,
               qt6-declarative-dev,
               qt6-l10n-tools,
               qt6-svg-dev,
               qt6-tools-dev,
               qt6-tools-dev-tools
Standards-Version: 3.9.6
Homepage: https://github.com/zaps166/QMPlay2

Package: qmplay2
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: yt-dlp
Description: Qt based media player/streamer/downloader--Qt6 version
 QMPlay2 is a video and audio player and is able to play all formats supported
 by ffmpeg and libmodplug, including J2B and SFX. It also supports audio CD,
 raw files and Rayman 2 music. It can browse and download YouTube and
 MyFreeMP3 content via included plugin widgets.
 .
 It also can support online radio streams.  Youtube playback requires a recent
 youtube-dlp, but the program will download it automatically if it can't be
 found on your system, and automatically update it if it runs into problems.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

%:
	dh $@ -Scmake+ninja

override_dh_auto_configure:
	dh_auto_configure -- \
	-D USE_UPDATES=OFF \
	-D CMAKE_BUILD_TYPE=RelWithDebInfo \
	-D BUILD_WITH_QT6=ON \
	-D USE_PORTAUDIO=ON \
	-D SOLID_ACTIONS_INSTALL_PATH="/usr/share/solid/actions" \
	-D USE_VULKAN=OFF \
	-D CMAKE_INTERPROCEDURAL_OPTIMIZATION=ON \
	-D USE_LINK_TIME_OPTIMIZATION=ON \
	-D USE_PCH=ON \
	-D USE_UBSAN=ON \
	-D USE_VULKAN=OFF \
	-D CMAKE_INTERPROCEDURAL_OPTIMIZATION=ON \
	-D USE_LINK_TIME_OPTIMIZATION=ON \
	-D USE_PCH=ON \
	-D USE_UBSAN=ON
#	exit 1

override_dh_auto_test:

# No dbgsym packages:
override_dh_strip:
	@echo "not building dbgsym packages for MX Linux"
	dh_strip --no-automatic-dbgsym

## qmplay2 24.12.06

=== src/qmvk/CMakeLists.txt ===
--- 
+++ 
@@ -67,6 +67,14 @@
     "*.cpp"
 )
 if(QMVK_NO_GRAPHICS)
+    if(QMVK_NO_SEMAPHORE)
+        list(REMOVE_ITEM QMVK_VULKAN_HDR
+            "${CMAKE_CURRENT_SOURCE_DIR}/Semaphore.hpp"
+        )
+        list(REMOVE_ITEM QMVK_VULKAN_SRC
+            "${CMAKE_CURRENT_SOURCE_DIR}/Semaphore.cpp"
+        )
+    endif()
     list(REMOVE_ITEM QMVK_VULKAN_HDR
         "${CMAKE_CURRENT_SOURCE_DIR}/GraphicsPipeline.hpp"
         "${CMAKE_CURRENT_SOURCE_DIR}/Image.hpp"

=== debian/changelog ===
qmplay2 (1:24.12.06-1mx23) mx; urgency=medium

  * Import new upstream 24.12.06 release:
    - optimize visualizations when wallpaper is used (especially for Qt6)
    - fix issues with some unsupported codecs for DXVA2/D3D11VA
    - fix loading Vulkan library for some Linux distributions
    - fix displaying covers for radio stations (regression)
    - improve applying custom styles for ASS/SSA subtitles
    - fix enlarging small covers when blur is disabled
    - add displaying frequency limit for FFT spectrum
    - fix MediaBrowser download file names on Qt 6.8
    - add bold font style for text subtitles
    - read CUE files containing binary data
    - use white subtitles color as default
    - fix playlist sorting for mixed case
    - allow to scale bitmap subtitles
    - add more YouTubeDL settings
    - update translations files
    - other minor fixes

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 18 Dec 2024 11:01:00 -0800

qmplay2 (1:24.06.16-1mx23+1) mx; urgency=medium

  * Import new upstream 24.06.16 release:
    - show less connection errors from Radio Browser.
    - fix choosing desired video stream.
    - fix colorspace for ARIB STD-B67.
    - improve recording status.
    - update translations.

  * Disable Vulkan, causes FTBFS now with older versions.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 22 Jun 2024 07:33:47 -0700

## qmplay2 25.01.19

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
if(APPLE)
    project(QMPlay2 LANGUAGES CXX OBJCXX)
else()
    project(QMPlay2 LANGUAGES CXX)
endif()

if (NOT ${CMAKE_GENERATOR} MATCHES "Ninja")
    message(FATAL_ERROR "Unsupported generator ${CMAKE_GENERATOR}. Ninja is the only supported generator.")
endif()

if(WIN32)
    set(CUSTOM_INCLUDE_DIR "" CACHE STRING "Custom include directory")
    set(CUSTOM_LINK_DIR "" CACHE STRING "Custom link directory")

    if(CUSTOM_INCLUDE_DIR)
        set(CMAKE_INCLUDE_PATH ${CUSTOM_INCLUDE_DIR})
        include_directories(${CUSTOM_INCLUDE_DIR})
    endif()
    if(CUSTOM_LINK_DIR)
        set(CMAKE_LIBRARY_PATH ${CUSTOM_LINK_DIR})
        link_directories(${CUSTOM_LINK_DIR})
    endif()
endif()

# Set default build type as Release
if(NOT CMAKE_BUILD_TYPE OR CMAKE_BUILD_TYPE STREQUAL "None")
    set(CMAKE_BUILD_TYPE "Release")
endif()

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/src/cmake/Modules")

include(FeatureSummary)

if(NOT CMAKE_HOST_WIN32 AND NOT ANDROID)
    find_package(PkgConfig REQUIRED)
else()
    find_package(DummyPkgConfig REQUIRED)
endif()

if((NOT DEFINED BUILD_WITH_QT6 OR BUILD_WITH_QT6) AND NOT DEFINED Qt6_FOUND AND (NOT DEFINED QT_QMAKE_EXECUTABLE OR QT_QMAKE_EXECUTABLE MATCHES "qmake6"))
    find_package(Qt6 6.1)
endif()
option(BUILD_WITH_QT6 "Build with Qt6" ${Qt6_FOUND})
add_feature_info(Qt6 BUILD_WITH_QT6 "Build with Qt6")

if(BUILD_WITH_QT6)
    set(QT_PREFIX Qt6)
    find_package(Qt6Widgets 6.1 REQUIRED)
    find_package(Qt6Core5Compat 6.1 REQUIRED)
else()
    set(QT_PREFIX Qt5)
    find_package(Qt5Widgets 5.15.2 REQUIRED)
endif()

pkg_check_modules(LIBAVFORMAT REQUIRED libavformat>=58.12.100)
pkg_check_modules(LIBAVCODEC REQUIRED libavcodec>=58.18.100)
pkg_check_modules(LIBSWSCALE REQUIRED libswscale>=5.1.100)
pkg_check_modules(LIBAVUTIL REQUIRED libavutil>=56.14.100)
pkg_check_modules(LIBSWRESAMPLE REQUIRED libswresample>=3.1.100)

set(CMAKE_LINK_DEPENDS_NO_SHARED ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOMOC_COMPILER_PREDEFINES OFF)

option(USE_PCH "Use precompiled headers" OFF)
add_feature_info(PCH USE_PCH "Use precompiled headers")

option(CMAKE_INTERPROCEDURAL_OPTIMIZATION "Enable link-time code generation" OFF)
add_feature_info("Interprocedural optimization" CMAKE_INTERPROCEDURAL_OPTIMIZATION "Enable link-time code generation")

if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
    set(DEFAULT_ALSA ON)
    set(DEFAULT_PORTAUDIO OFF)
elseif(ANDROID)
    set(DEFAULT_ALSA OFF)
    set(DEFAULT_PORTAUDIO OFF)
elseif(HAIKU)
    set(DEFAULT_ALSA OFF)
    set(DEFAULT_PORTAUDIO OFF)
else()
    set(DEFAULT_ALSA OFF)
    set(DEFAULT_PORTAUDIO ON)
endif()

if(APPLE OR ANDROID)
    set(DEFAULT_CUVID OFF)
else()
    set(DEFAULT_CUVID ON)
endif()

add_definitions(-D__STDC_CONSTANT_MACROS -D__STDC_LIMIT_MACROS -DQT_USE_QSTRINGBUILDER)

if (BUILD_WITH_QT6)
    add_definitions(-DQ_ENTER_EVENT=QEnterEvent)
else()
    add_definitions(-DQ_ENTER_EVENT=QEvent)
endif()

option(USE_UPDATES "Build with software updates" ON)
add_feature_info(Updates USE_UPDATES "Build with software updates")

if(WIN32)
    option(USE_CMD "Show CMD when running QMPlay2" OFF)
    mark_as_advanced(USE_CMD)
    add_feature_info(CMD USE_CMD "Show CMD when running QMPlay2")
endif()

option(USE_OPENGL "Build with OpenGL support" ON)
add_feature_info(OpenGL USE_OPENGL "Build with OpenGL support")
if(USE_OPENGL)
    add_definitions(-DUSE_OPENGL)
    if(BUILD_WITH_QT6)
        find_package(Qt6OpenGL REQUIRED)
        find_package(Qt6OpenGLWidgets REQUIRED)
    endif()
endif()

if(NOT APPLE)
    if (BUILD_WITH_QT6)
        get_target_property(${QT_PREFIX}GuiFeatures ${QT_PREFIX}::Gui QT_ENABLED_PUBLIC_FEATURES)
    else()
        get_target_property(${QT_PREFIX}GuiFeatures ${QT_PREFIX}::Gui INTERFACE_QT_ENABLED_FEATURES)
    endif()
    list(FIND ${QT_PREFIX}GuiFeatures "vulkan" ${QT_PREFIX}Vulkan)
    if(${${QT_PREFIX}Vulkan} GREATER -1)
        set(VULKAN_AVAILABLE ON)
    endif()
endif()
option(USE_VULKAN "Build with Vulkan support" ${VULKAN_AVAILABLE})
add_feature_info(Vulkan USE_VULKAN "Build with Vulkan support")
if(USE_VULKAN)
    add_definitions(-DUSE_VULKAN)
endif()

option(USE_GLSLC "Compile Vulkan shaders" OFF)
add_feature_info(GLSLC USE_GLSLC "Compile Vulkan shaders")

if(NOT WIN32 AND NOT APPLE AND NOT ANDROID AND NOT HAIKU)
    option(USE_FREEDESKTOP_NOTIFICATIONS "Use Freedesktop notifications" ON)
    add_feature_info("Freedesktop notifications" USE_FREEDESKTOP_NOTIFICATIONS "Use Freedesktop notifications")

    option(USE_DBUS_PM "Use D-Bus power management" ON)
    add_feature_info("Use D-Bus power management" USE_DBUS_PM "Use D-Bus power management")
endif()

option(USE_LIBASS "Build with libass support" ON)
add_feature_info(libass USE_LIBASS "Build with libass support")

if(NOT DEFINED USE_RUBBERBAND)
    pkg_check_modules(RUBBERBAND rubberband>=3.0.0)
endif()
option(USE_RUBBERBAND "Build with RubberBand support" ${RUBBERBAND_FOUND})
add_feature_info(RubberBand USE_RUBBERBAND "Build with RubberBand support")

option(USE_INPUTS "Build with Inputs module" ON)
add_feature_info(Inputs USE_INPUTS "Build with Inputs module")

option(USE_MODPLUG "Build with Modplug module" ON)
add_feature_info(Modplug USE_MODPLUG "Build with Modplug module")

option(USE_EXTENSIONS "Build with Extensions module" ON)
add_feature_info(Extensions USE_EXTENSIONS "Build with Extensions module")

if(USE_EXTENSIONS)
    option(USE_MEDIABROWSER "Build with MediaBrowser support" ON)
    add_feature_info(MediaBrowser USE_MEDIABROWSER "Build with MediaBrowser support")

    option(USE_LASTFM "Build with LastFM support" ON)
    add_feature_info(LastFM USE_LASTFM "Build with LastFM support")

    option(USE_LYRICS "Build with lyrics support" ON)
    add_feature_info(Lyrics USE_LYRICS "Build with lyrics support")

    option(USE_RADIO "Build with Radio Browser support" ON)
    add_feature_info(Radio USE_RADIO "Build with Radio Browser support")

    option(USE_YOUTUBE "Build with YouTube support" ON)
    add_feature_info(YouTube USE_YOUTUBE "Build with YouTube support")

    option(USE_OPENSUBTITLES "Build with OpenSubtitles support" ON)
    add_feature_info(OpenSubtitles USE_OPENSUBTITLES "Build with OpenSubtitles support")
endif()

if(USE_YOUTUBE OR USE_MEDIABROWSER)
    set(USE_YOUTUBEDL ON)
    add_definitions(-DUSE_YOUTUBEDL)
else()
    set(USE_YOUTUBEDL OFF)
endif()

if(USE_EXTENSIONS AND NOT WIN32 AND NOT APPLE AND NOT ANDROID AND NOT HAIKU)
    option(USE_MPRIS2 "Build Extensions with MPRIS2 support" ON)
    add_feature_info(MPRIS2 USE_MPRIS2 "Build Extensions with MPRIS2 support")
endif()

option(USE_VISUALIZATIONS "Build with Visualizations module" ON)
add_feature_info(Visualizations USE_VISUALIZATIONS "Build with Visualizations module")

option(USE_AUDIOFILTERS "Build with AudioFilters module" ON)
add_feature_info(AudioFilters USE_AUDIOFILTERS "Build with AudioFilters module")

if(USE_AUDIOFILTERS)
    pkg_check_modules(LIBAVFILTER libavfilter>=8.44.100)
    set(DEFAULT_LIBAVFILTER ${LIBAVFILTER_FOUND})

    option(USE_AVAUDIOFILTER "Build with AvAudioFilter support" ${DEFAULT_LIBAVFILTER})
    add_feature_info(AvAAudioFilter USE_AVAUDIOFILTER "Build with AvAudioFilter support")
endif()

option(USE_VIDEOFILTERS "Build with VideoFilters module" ON)
add_feature_info(VideoFilters USE_VIDEOFILTERS "Build with VideoFilters module")

option(USE_PORTAUDIO "Build with PortAudio module" ${DEFAULT_PORTAUDIO})
add_feature_info(PortAudio USE_PORTAUDIO "Build with PortAudio module")

if(NOT DEFINED USE_TAGLIB)
    find_package(TagLib)
endif()
option(USE_TAGLIB "Build with tags editor" ${TAGLIB_FOUND})
add_feature_info(TagLib USE_TAGLIB "Build with tags editor")

if(NOT DEFINED LIBAVUTIL_VERSION)
    set(LIBAVUTIL_VERSION "58.29.100")
endif()
if(NOT DEFINED USE_FFMPEG_VKVIDEO AND USE_VULKAN AND ${LIBAVUTIL_VERSION} VERSION_GREATER_EQUAL "58.29.100")
    set(DEFAULT_USE_FFMPEG_VKVIDEO ON)
endif()
option(USE_FFMPEG_VKVIDEO "Build VkVideo acceleration into FFmpeg" ${DEFAULT_USE_FFMPEG_VKVIDEO})
add_feature_info(VkVideo USE_FFMPEG_VKVIDEO "Build VkVideo acceleration into FFmpeg")

if(NOT DEFINED USE_FFMPEG_VAAPI)
    pkg_check_modules(LIBS_VAAPI libva>=1.1.0 libva-drm)
endif()
option(USE_FFMPEG_VAAPI "Build VAAPI acceleration into FFmpeg" ${LIBS_VAAPI_FOUND})
add_feature_info(VAAPI USE_FFMPEG_VAAPI "Build VAAPI acceleration into FFmpeg")

if(WIN32)
    option(USE_FFMPEG_DXVA2 "Build DXVA2 acceleration into FFmpeg" ON)
    add_feature_info(DXVA2 USE_FFMPEG_DXVA2 "Build DXVA2 acceleration into FFmpeg")

    if(USE_VULKAN)
        option(USE_FFMPEG_D3D11VA "Build D3D11VA acceleration into FFmpeg" ON)
        add_feature_info(DXVA2 USE_FFMPEG_D3D11VA "Build D3D11VA acceleration into FFmpeg")
    endif()
endif()

if(APPLE)
    option(USE_FFMPEG_VTB "Build VideoToolBox acceleration into FFmpeg" ON)
    add_feature_info(VTB USE_FFMPEG_VTB "Build VideoToolBox acceleration into FFmpeg")
endif()

if(NOT DEFINED USE_FFMPEG_AVDEVICE)
    if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
        pkg_check_modules(LIBAVDEVICE libavdevice)
        set(DEFAULT_AVDEVICE ${LIBAVDEVICE_FOUND})
    else()
        set(DEFAULT_AVDEVICE OFF)
    endif()
endif()
option(USE_FFMPEG_AVDEVICE "Build FFmpeg with libavdevice suport" ${DEFAULT_AVDEVICE})
add_feature_info(libavdevice USE_FFMPEG_AVDEVICE "Build FFmpeg with libavdevice suport")

if(NOT DEFINED USE_AUDIOCD)
    pkg_check_modules(LIBCD libcdio libcddb)
endif()
option(USE_AUDIOCD "Build with AudioCD module" ${LIBCD_FOUND})
add_feature_info(AudioCD USE_AUDIOCD "Build with AudioCD module")

option(USE_ALSA "Build with ALSA module" ${DEFAULT_ALSA})
add_feature_info(ALSA USE_ALSA "Build with ALSA module")

if(NOT DEFINED USE_CHIPTUNE_GME)
    find_package(GME)
endif()
option(USE_CHIPTUNE_GME "Build Chiptune with GME support" ${LIBGME_FOUND})
add_feature_info("Chiptune GME" USE_CHIPTUNE_GME "Build Chiptune with GME support")

if(NOT DEFINED USE_CHIPTUNE_SID)
    pkg_check_modules(LIBSIDPLAYFP libsidplayfp)
endif()
option(USE_CHIPTUNE_SID "Build Chiptune with SIDPLAY support" ${LIBSIDPLAYFP_FOUND})
add_feature_info("Chiptune SIDPLAY" USE_CHIPTUNE_SID "Build Chiptune with SIDPLAY support")

if(NOT DEFINED USE_PULSEAUDIO)
    pkg_check_modules(LIBPULSE libpulse-simple)
endif()
option(USE_PULSEAUDIO "Build with PulseAudio module" ${LIBPULSE_FOUND})
add_feature_info(PulseAudio USE_PULSEAUDIO "Build with PulseAudio module")

if(NOT DEFINED USE_PIPEWIRE)
    pkg_check_modules(LIBPIPEWIRE libpipewire-0.3)
endif()
option(USE_PIPEWIRE "Build with PipeWire module" ${LIBPIPEWIRE_FOUND})
add_feature_info(PipeWire USE_PIPEWIRE "Build with PipeWire module")

if(NOT DEFINED USE_XVIDEO)
    pkg_check_modules(LIB_X11_XV x11 xv)
endif()
option(USE_XVIDEO "Build with XVideo module" ${LIB_X11_XV_FOUND})
add_feature_info(XVideo USE_XVIDEO "Build with XVideo module")

option(USE_CUVID "Build with CUVID module" ${DEFAULT_CUVID})
add_feature_info(CUVID USE_CUVID "Build with CUVID module")

option(USE_NOTIFY "Build additional notifications module" ON)
add_feature_info(Notifications USE_NOTIFY "Build additional notifications module")

set(LANGUAGES "All" CACHE STRING "A space-seperated list of translations to compile into QMPlay2 or \"All\"")

if(USE_FFMPEG_VAAPI)
    option(FIND_HWACCEL_DRIVERS_PATH "Find drivers path for hwaccel, useful for universal package" OFF)
    add_feature_info(FindHwaccelDrivers FIND_HWACCEL_DRIVERS_PATH "Find drivers path for hwaccel")
endif()

if(NOT WIN32)
    # get QMPlay2 version by running the version script
    execute_process(
        COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/version
        OUTPUT_VARIABLE QMPLAY2_VERSION
        OUTPUT_STRIP_TRAILING_WHITESPACE
    )
    string(REPLACE "." "-" QMPLAY2_DATE ${QMPLAY2_VERSION})
    string(PREPEND QMPLAY2_DATE "20")
endif()

option(USE_GIT_VERSION "Append Git HEAD to QMPlay2 version (if exists)" ON)

=== debian/changelog ===
qmplay2 (1:25.01.19-1mx23) mx; urgency=medium

  * Import new upstream 25.01.19 release:
    Changes in QMPlay2 25.01.19:
    - store maximized state when closing from full screen.
    - pass 'yt-dlp' URL argument as 'referer'.
    - improve still image stream detection.
    - allow for local stream recording.
    - show left panel in compact view.
    - fix YouTube live streams.
    - other minor fixes.
    Changes in QMPlay2 24.12.28:
    - add option to maintain panels size when resizing main window.
    - add input dialog for zoom and add precise zoom control.
    - live update when changing values in input dialogs.
    - add FFmpeg audio filters.
    - teletext improvements.
    - fix various crashes.
    - other minor fixes.
    Changes in QMPlay2 24.12.23:
    - use relative paths in portable mode when QMPlay2 portable directory
      is chosen.
    - add option for experimental FFmpeg features (useful for HLS subtitles).
    - fix playback of video which has variable and low FPS.
    - add drag and drop for cover picture in tag editor.
    - fix playlist row colors on Windows 11 Dark style.
    - improve teletext (option to set teletext page).
    - hardware deinterlacing fixes and optimization.
    - add option to set subtitles solid background.
    - add option to set default quality in yt-dlp.
    - bitmap subtitles aspect ratio fixes.
    - add OpenSubtitles browser.
    - translation improvements.
    - add custom aspect ratio.
    - add integer scaling.
    - other minor fixes.

  * Update d/copyright.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 30 Jan 2025 08:12:23 -0800

## qmplay2 25.06.11

=== src/qmplay2/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(libqmplay2)

set(QMPLAY2_HDR
    QMPlay2Lib.hpp
    QMPlay2Core.hpp
    Functions.hpp
    Settings.hpp
    Module.hpp
    ModuleParams.hpp
    ModuleCommon.hpp
    Playlist.hpp
    Reader.hpp
    Demuxer.hpp
    Decoder.hpp
    VideoFilters.hpp
    VideoFilter.hpp
    DeintHWPrepareFilter.hpp
    AudioFilter.hpp
    Writer.hpp
    QMPlay2Extensions.hpp
    LineEdit.hpp
    Slider.hpp
    QMPlay2OSD.hpp
    InDockW.hpp
    LibASS.hpp
    ColorButton.hpp
    ImgScaler.hpp
    SndResampler.hpp
    VideoWriter.hpp
    SubsDec.hpp
    ByteArray.hpp
    Packet.hpp
    Frame.hpp
    StreamInfo.hpp
    DockWidget.hpp
    IOController.hpp
    ChapterProgramInfo.hpp
    PacketBuffer.hpp
    NetworkAccess.hpp
    IPC.hpp
    Version.hpp
    VideoAdjustment.hpp
    Notifies.hpp
    NotifiesTray.hpp
    StreamMuxer.hpp
    Sphere.hpp
    X11BypassCompositor.hpp
    VideoOutputCommon.hpp
    HWDecContext.hpp
    GPUInstance.hpp
    FFT.hpp
    PlaylistEntry.hpp
)

set(QMPLAY2_SRC
    QMPlay2Core.cpp
    Functions.cpp
    Settings.cpp
    Module.cpp
    ModuleParams.cpp
    ModuleCommon.cpp
    Playlist.cpp
    Reader.cpp
    Demuxer.cpp
    Decoder.cpp
    VideoFilters.cpp
    VideoFilter.cpp
    DeintHWPrepareFilter.cpp
    AudioFilter.cpp
    Writer.cpp
    QMPlay2Extensions.cpp
    LineEdit.cpp
    Slider.cpp
    QMPlay2OSD.cpp
    InDockW.cpp
    LibASS.cpp
    ColorButton.cpp
    ImgScaler.cpp
    SndResampler.cpp
    VideoWriter.cpp
    SubsDec.cpp
    Packet.cpp
    Frame.cpp
    StreamInfo.cpp
    DockWidget.cpp
    PacketBuffer.cpp
    NetworkAccess.cpp
    Version.cpp
    Notifies.cpp
    NotifiesTray.cpp
    StreamMuxer.cpp
    Sphere.cpp
    X11BypassCompositor.cpp
    VideoOutputCommon.cpp
    GPUInstance.cpp
)

if(WIN32)
    list(APPEND QMPLAY2_SRC IPC_Windows.cpp)
else()
    list(APPEND QMPLAY2_SRC IPC_Unix.cpp)
endif()

if(USE_GIT_VERSION AND QMPLAY2_GIT_HEAD)
    set_source_files_properties(Version.cpp PROPERTIES COMPILE_DEFINITIONS QMPlay2GitHEAD="-git-${QMPLAY2_GIT_HEAD}")
endif()

if(USE_OPENGL)
    set(QMPLAY2_OPENGL_HDR
        opengl/OpenGLInstance.hpp
        opengl/OpenGLWriter.hpp
        opengl/OpenGLCommon.hpp
        opengl/OpenGLWindow.hpp
        opengl/OpenGLWidget.hpp
        opengl/OpenGLVertices.hpp
        opengl/OpenGLHWInterop.hpp
    )
    set(QMPLAY2_OPENGL_SRC
        opengl/OpenGLInstance.cpp
        opengl/OpenGLWriter.cpp
        opengl/OpenGLCommon.cpp
        opengl/OpenGLWindow.cpp
        opengl/OpenGLWidget.cpp
        opengl/opengl.qrc
    )

    if(BUILD_WITH_QT6)
        list(APPEND OPENGL_LIBS Qt6::OpenGL Qt6::OpenGLWidgets)
        get_target_property(QtGui_Enabled_Features Qt6::Gui QT_ENABLED_PUBLIC_FEATURES)
    endif()

    if((${QT_PREFIX}Gui_OPENGL_IMPLEMENTATION STREQUAL GLESv2) OR (QtGui_Enabled_Features MATCHES "opengles"))
        if(NOT WIN32)
            list(APPEND OPENGL_LIBS GLESv2)
        endif()
    elseif(${QT_PREFIX}Gui_OPENGL_IMPLEMENTATION STREQUAL GLES)
        message(SEND_ERROR "OpenGL|ES 1.0 is not supported!")
    endif()
endif()

if(USE_VULKAN)
    set(QMPLAY2_VULKAN_HDR
        vulkan/VulkanBufferPool.hpp
        vulkan/VulkanHWInterop.hpp
        vulkan/VulkanImagePool.hpp
        vulkan/VulkanInstance.hpp
        vulkan/VulkanWindow.hpp
        vulkan/VulkanWriter.hpp
        vulkan/VulkanYadifDeint.hpp
    )
    set(QMPLAY2_VULKAN_SRC
        vulkan/VulkanBufferPool.cpp
        vulkan/VulkanHWInterop.cpp
        vulkan/VulkanImagePool.cpp
        vulkan/VulkanInstance.cpp
        vulkan/VulkanWindow.cpp
        vulkan/VulkanWriter.cpp
        vulkan/VulkanYadifDeint.cpp
    )
    set(VULKAN_SHADERS
        vulkan/shaders/osd.vert
        vulkan/shaders/osd_ass.frag
        vulkan/shaders/osd_av.frag
        vulkan/shaders/video.frag
        vulkan/shaders/video.vert
        vulkan/shaders/yadif.comp
    )
    set(VULKAN_SHADERS_INCLUDE
        shaderscommon/colorspace.glsl
        shaderscommon/hsl.glsl
    )

    if(USE_GLSLC) # Shaders compilation
        foreach(VULKAN_SHADER ${VULKAN_SHADERS})
            qmvk_add_shader(${CMAKE_CURRENT_SOURCE_DIR}/${VULKAN_SHADER} ${VULKAN_SHADERS_INCLUDE})
        endforeach()

        add_custom_target( # Needed to display GLSL files in QtCreator
            VulkanShaders
            SOURCES ${VULKAN_SHADERS} ${VULKAN_SHADERS_INCLUDE}
            DEPENDS ${QMVK_SHADER_COMPILED_FILES}
        )
    else()
        file(GLOB QMVK_SHADER_COMPILED_FILES
            "${CMAKE_CURRENT_SOURCE_DIR}/vulkan/shaders/spv/*.spv"
        )
    endif()

    # Compiled shaders QRC generation

    set(VULKAN_SHADER_QRC_FILE "${CMAKE_CURRENT_BINARY_DIR}/vulkan_shaders.qrc")
    list(APPEND QMPLAY2_VULKAN_SRC
        ${VULKAN_SHADER_QRC_FILE}
    )

    set(VULKAN_SHADER_QRC_FILE_TMP "${VULKAN_SHADER_QRC_FILE}.tmp")

    if(ANDROID)
        set(VULKAN_SHADER_QRC_THRESHOLD " threshold=\"100\"") # Otherwise doesn't link with zstd in 6.6.2
    endif()

    foreach(SHADER_COMPILED_FILE ${QMVK_SHADER_COMPILED_FILES})
        get_filename_component(SHADER_COMPILED_FILE_NAME ${SHADER_COMPILED_FILE} NAME)
        set(SHADER_QRC_CONTENT
            ${SHADER_QRC_CONTENT}
            "  <file\ alias=\"${SHADER_COMPILED_FILE_NAME}\"${VULKAN_SHADER_QRC_THRESHOLD}>${SHADER_COMPILED_FILE}</file>\n"
        )
    endforeach()
    file(WRITE ${VULKAN_SHADER_QRC_FILE_TMP}
        "<RCC>\n <qresource\ prefix=\"/vulkan\">\n"
        ${SHADER_QRC_CONTENT}
        " </qresource>\n</RCC>\n"
    )

    add_custom_command(
        OUTPUT ${VULKAN_SHADER_QRC_FILE}
        DEPENDS ${QMVK_SHADER_COMPILED_FILES}
        COMMAND ${CMAKE_COMMAND} -E copy ${VULKAN_SHADER_QRC_FILE_TMP} ${VULKAN_SHADER_QRC_FILE}
    )

    # No need to add VulkanShaders target dependency to libqmplay2,
    # because generated QRC file is added into source file list.
endif()

add_definitions(-DQMPLAY2SHAREDLIB_LIBRARY)
if(USE_VULKAN)
    add_definitions(-DQMVK_LIBRARY)
endif()

if(USE_FREEDESKTOP_NOTIFICATIONS)
    list(APPEND QMPLAY2_HDR NotifiesFreedesktop.hpp)
    list(APPEND QMPLAY2_SRC NotifiesFreedesktop.cpp)
    if(BUILD_WITH_QT6)
        qt6_add_dbus_interface(QMPLAY2_SRC org.freedesktop.Notifications.xml notifications_interface)
    else()
        qt5_add_dbus_interface(QMPLAY2_SRC org.freedesktop.Notifications.xml notifications_interface)
    endif()
    add_definitions(-DNOTIFIES_FREEDESKTOP)
elseif(APPLE)
    list(APPEND QMPLAY2_HDR NotifiesMacOS.hpp)
    list(APPEND QMPLAY2_SRC NotifiesMacOS.mm)
    add_definitions(-DNOTIFIES_MACOS)
endif()

if(USE_FREEDESKTOP_NOTIFICATIONS OR USE_DBUS_PM OR USE_MPRIS2)
    set(DBUS ${QT_PREFIX}::DBus)
endif()

if(USE_QML)
    list(APPEND QMPLAY2_HDR
        CommonJS.hpp
        TreeWidgetJS.hpp
        NetworkAccessJS.hpp
    )
    list(APPEND QMPLAY2_SRC
        CommonJS.cpp
        TreeWidgetJS.cpp
        NetworkAccessJS.cpp
    )
    add_definitions(-DUSE_QML)
    set(QML ${QT_PREFIX}::Qml)
endif()

if(USE_YOUTUBEDL)
    list(APPEND QMPLAY2_HDR
        YouTubeDL.hpp
    )
    list(APPEND QMPLAY2_SRC
        YouTubeDL.cpp
    )
endif()

set(QMPLAY2_RESOURCES
    languages.qrc
)

if(USE_LIBASS)
    add_definitions(-DQMPLAY2_LIBASS)
    pkg_check_modules(LIBASS REQUIRED libass)
    include_directories(${LIBASS_INCLUDE_DIRS})
    link_directories(${LIBASS_LIBRARY_DIRS})
endif()

if(USE_RUBBERBAND)
    add_definitions(-DQMPLAY2_RUBBERBAND)
    pkg_check_modules(RUBBERBAND REQUIRED rubberband>=3.0.0)
    include_directories(${RUBBERBAND_INCLUDE_DIRS})
    link_directories(${RUBBERBAND_LIBRARY_DIRS})
    list(APPEND LIBQMPLAY2_LIBS ${RUBBERBAND_LIBRARIES})
endif()

add_library(${PROJECT_NAME} SHARED
    ${QMPLAY2_HDR}
    ${QMPLAY2_SRC}
    ${QMPLAY2_RESOURCES}
    ${QMPLAY2_OPENGL_HDR}
    ${QMPLAY2_OPENGL_SRC}
    ${QMPLAY2_VULKAN_HDR}
    ${QMPLAY2_VULKAN_SRC}
)
set_target_properties(${PROJECT_NAME} PROPERTIES PREFIX "")

if(USE_PCH)
    if(APPLE)
        set_source_files_properties(NotifiesMacOS.mm PROPERTIES SKIP_PRECOMPILE_HEADERS ON)
    endif()
    target_precompile_headers(${PROJECT_NAME} PRIVATE
        ${QMPLAY2_HDR}
        ${QMPLAY2_OPENGL_HDR}
        ${QMPLAY2_VULKAN_HDR}
    )
endif()

target_include_directories(
    ${PROJECT_NAME}
    PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${LIBAVFORMAT_INCLUDE_DIRS}
    ${LIBAVCODEC_INCLUDE_DIRS}
    ${LIBSWSCALE_INCLUDE_DIRS}
    ${LIBAVUTIL_INCLUDE_DIRS}
    ${LIBSWRESAMPLE_INCLUDE_DIRS}
)
target_link_directories(
    ${PROJECT_NAME}
    PUBLIC
    ${LIBAVFORMAT_LIBRARY_DIRS}
    ${LIBAVCODEC_LIBRARY_DIRS}
    ${LIBSWSCALE_LIBRARY_DIRS}
    ${LIBAVUTIL_LIBRARY_DIRS}
    ${LIBSWRESAMPLE_LIBRARY_DIRS}
)

if(APPLE)
    target_link_libraries(${PROJECT_NAME}
        PRIVATE
        ${APPKIT_LIBRARY}
    )
endif()

if(USE_LIBASS AND (NOT WIN32 OR CMAKE_HOST_WIN32))
    list(APPEND LIBQMPLAY2_LIBS ${LIBASS_LIBRARIES})
endif()

if(WIN32)
    target_link_libraries(${PROJECT_NAME}
        PRIVATE
        powrprof
    )

    set(CUSTOM_LIBQMPLAY2_LIBRARIES "" CACHE STRING "Custom libraries for libqmplay2")
    if(CUSTOM_LIBQMPLAY2_LIBRARIES)
        separate_arguments(CUSTOM_LIBQMPLAY2_LIBRARIES)
        list(APPEND LIBQMPLAY2_LIBS ${CUSTOM_LIBQMPLAY2_LIBRARIES})
    endif()

    install(TARGETS ${PROJECT_NAME} RUNTIME DESTINATION ${CMAKE_INSTALL_PREFIX})
else()
    install(TARGETS ${PROJECT_NAME} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
    if(NOT APPLE)
        install(FILES ${QMPLAY2_HDR} DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/QMPlay2")
    endif()
endif()

if(USE_DBUS_PM)
    target_compile_definitions(${PROJECT_NAME}
        PUBLIC
        DBUS_PM
    )
endif()

target_link_libraries(${PROJECT_NAME}
    PUBLIC
    ${QT_PREFIX}::Core
    ${QT_PREFIX}::Gui
    ${QT_PREFIX}::Widgets
    ${QT_PREFIX}::Svg
    ${LIBAVFORMAT_LIBRARIES}
    ${LIBAVCODEC_LIBRARIES}
    ${LIBSWSCALE_LIBRARIES}
    ${LIBAVUTIL_LIBRARIES}
    ${LIBSWRESAMPLE_LIBRARIES}
    ${OPENGL_LIBS}
    ${DBUS}
    PRIVATE
    ${QML}
    ${LIBQMPLAY2_LIBS}
)
if(USE_VULKAN)
    if(ANDROID)
        target_link_libraries(${PROJECT_NAME}
            PRIVATE
            $<TARGET_OBJECTS:QmVk>
        )
    else()
        target_link_libraries(${PROJECT_NAME}
            PRIVATE
            $<TARGET_LINKER_FILE:QmVk>
        )
    endif()
    target_compile_definitions(${PROJECT_NAME}
        PUBLIC
        $<TARGET_PROPERTY:QmVk,INTERFACE_COMPILE_DEFINITIONS>
    )
    target_include_directories(${PROJECT_NAME}
        PUBLIC
        $<TARGET_PROPERTY:QmVk,INTERFACE_INCLUDE_DIRECTORIES>
    )
endif()
if(BUILD_WITH_QT6)
    target_link_libraries(${PROJECT_NAME}
        PUBLIC
        Qt6::Core5Compat # QTextCodec
    )
endif()

if(USE_VULKAN AND NOT WIN32 AND NOT ANDROID)
    target_link_libraries(${PROJECT_NAME}
        PRIVATE
        dl
    )
endif()

macro(libqmplay2_set_target_params)
    target_link_libraries(${PROJECT_NAME}
        PRIVATE
        $<TARGET_PROPERTY:libqmplay2,INTERFACE_LINK_LIBRARIES>
        $<TARGET_LINKER_FILE:libqmplay2>
    )
    target_link_directories(${PROJECT_NAME}
        PRIVATE
        $<TARGET_PROPERTY:libqmplay2,INTERFACE_LINK_DIRECTORIES>
    )
    target_include_directories(${PROJECT_NAME}
        PRIVATE
        $<TARGET_PROPERTY:libqmplay2,INTERFACE_INCLUDE_DIRECTORIES>
    )
    target_compile_definitions(${PROJECT_NAME}
        PRIVATE
        $<TARGET_PROPERTY:libqmplay2,INTERFACE_COMPILE_DEFINITIONS>
    )
endmacro()

=== debian/changelog ===
qmplay2 (1:25.06.11-1mx21) mx; urgency=medium

  * Import new upstream 25.06.11 release:
    - M3U: Add support for "EXTVLCOPT" (User-Agent and Referer HTTP headers).
    - Visualizations: Fix repaint issues with wallpaper.
    - Add "CompactPlaylist" hidden setting.
    - various Wayland improvements.
    - add option to start in tray.
    - fixes in stream recording.
    - other minor fixes.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 26 Jun 2025 16:32:28 -0700

=== debian/control ===
--- 
+++ 
@@ -16,24 +16,23 @@
                libjack-dev,
                libpipewire-0.3-dev,
                libpulse-dev,
-               libqt6opengl6-dev,
+               libqt5opengl5-dev (>= 5.15.2),
+               libqt5svg5-dev (>= 5.15.2),
+               libqt5x11extras5-dev (>= 5.15.2),
                librubberband-dev (>= 3.0),
                libsidplayfp-dev (>= 1.6),
                libtag1-dev (>= 1.9),
                libva-dev,
-#               libvulkan-dev,
+#               libvdpau-dev,
+               libvulkan-dev,
                libxv-dev,
                ninja-build,
                pkgconf,
                portaudio19-dev,
-               qt6-5compat-dev,
-               qt6-base-dev,
-               qt6-base-dev-tools,
-               qt6-declarative-dev,
-               qt6-l10n-tools,
-               qt6-svg-dev,
-               qt6-tools-dev,
-               qt6-tools-dev-tools
+               qtbase5-dev (>= 5.15.2),
+               qtdeclarative5-dev (>= 5.15.2),
+               qttools5-dev (>= 5.15.2),
+               qttools5-dev-tools (>= 5.15.2)
 Standards-Version: 3.9.6
 Homepage: https://github.com/zaps166/QMPlay2
 
@@ -41,7 +40,7 @@
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Recommends: yt-dlp
-Description: Qt based media player/streamer/downloader--Qt6 version
+Description: Qt based media player/streamer/downloader
  QMPlay2 is a video and audio player and is able to play all formats supported
  by ffmpeg and libmodplug, including J2B and SFX. It also supports audio CD,
  raw files and Rayman 2 music. It can browse and download YouTube and

## qmplay2 25.06.27

=== debian/changelog ===
qmplay2 (1:25.06.27-1mx25) mx; urgency=medium

  * Import new upstream 25.06.27 release:
    - Wayland: fix missing AudioCD and Tone generator context menus.
    - always close panels with small delay when mouse leaves.
    - fix window positioning on multi-monitor configuration.
    - Wayland: fix video freeze on some compositors.
    - remove character limit for yt-dlp parameters.
    - ALSA: add SND_PCM_FORMAT_S24_3LE format.
    - display size grip on Windows.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 31 Jul 2025 12:52:58 -0700

qmplay2 (1:25.06.11-1mx23) mx; urgency=medium

  * Import new upstream 25.06.11 release:
    - M3U: Add support for "EXTVLCOPT" (User-Agent and Referer HTTP headers).
    - Visualizations: Fix repaint issues with wallpaper.
    - Add "CompactPlaylist" hidden setting.
    - various Wayland improvements.
    - add option to start in tray.
    - fixes in stream recording.
    - other minor fixes.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 26 Jun 2025 16:32:28 -0700
